package com.bzd.web.controller.mdyy;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.mdyy.SMdyyglMdysjqChiefmainsalesplanService;

import java.util.List;

/**
*
* 首主销售计划表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "mdyygl/smdyyglmdysjqchiefmainsalesplan")
public class SMdyyglMdysjqChiefmainsalesplanController extends BaseController {

    // 页面跳转前缀
    private String prefix = "mdyy";

    @Autowired
    private SMdyyglMdysjqChiefmainsalesplanService sMdyyglMdysjqChiefmainsalesplanService;

    /**
    * 首主销售计划表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("mdyygl:mdyy:view")
    @GetMapping("/sMdyyglMdysjqChiefmainsalesplanAdd")
    public String add() {
        return prefix + "/SMdyyglMdysjqChiefmainsalesplanAdd";
    }

    /**
    * 首主销售计划表 新增
    *
    * @return
    */
    @Log(title = "首主销售计划表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sMdyyglMdysjqChiefmainsalesplanAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sMdyyglMdysjqChiefmainsalesplanService.addSMdyyglMdysjqChiefmainsalesplan(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 首主销售计划表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("mdyygl:mdyy:view")
    @GetMapping("/sMdyyglMdysjqChiefmainsalesplanView")
    public String smdyyglmdysjqchiefmainsalesplanListView() {
        return prefix + "/SMdyyglMdysjqChiefmainsalesplanList";
    }

    /**
    * 首主销售计划表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("mdyygl:mdyy:sMdyyglMdysjqChiefmainsalesplanList")
    @PostMapping("/sMdyyglMdysjqChiefmainsalesplanList")
    @ResponseBody
    public TableDataInfo smdyyglmdysjqchiefmainsalesplanList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sMdyyglMdysjqChiefmainsalesplanService.findSMdyyglMdysjqChiefmainsalesplanList(pd);
        return getDataTable(pageData);
    }

    /**
    * 首主销售计划表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("mdyygl:mdyy:remove")
    @Log(title = "首主销售计划表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sMdyyglMdysjqChiefmainsalesplanRemove")
    @ResponseBody
    public AjaxResult smdyyglmdysjqchiefmainsalesplanRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sMdyyglMdysjqChiefmainsalesplanService.SMdyyglMdysjqChiefmainsalesplanRemove(pd);
        return toAjax(integer);
    }

    /**
    * 首主销售计划表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("mdyygl:mdyy:edit")
    @GetMapping("/sMdyyglMdysjqChiefmainsalesplanEdit/{id}")
    public String smdyyglmdysjqchiefmainsalesplanView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sMdyyglMdysjqChiefmainsalesplanService.findSMdyyglMdysjqChiefmainsalesplanList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/smdyyglmdysjqchiefmainsalesplanPageEdit";
        }
        return prefix+ "/smdyyglmdysjqchiefmainsalesplanEdit";
    }

    /**
    * 首主销售计划表保存修改的数据
    */
    @RequiresPermissions("mdyygl:mdyy:edit")
    @Log(title = "首主销售计划表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sMdyyglMdysjqChiefmainsalesplanEdit")
    @ResponseBody
    public AjaxResult smdyyglmdysjqchiefmainsalesplanEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sMdyyglMdysjqChiefmainsalesplanService.updateSMdyyglMdysjqChiefmainsalesplan(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表smdyyglmdysjqchiefmainsalesplan with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表smdyyglmdysjqchiefmainsalesplan with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
